// matriz.c
// Created 14/07/00; 10:08:13 a.m.
#include <nostub.h>
#include <all.h>
#include "matriz.h"


//The following has been changed.  It allocates memory
//as one big chunk now.  Instead of several smaller chunks.
//The first part of that memory part will be loaded with
//pointers to later parts of the same memory block.

//So now all that it takes to free the memory is the free()
//command.
MatType dim(int NumRow, int NumCol)
{
	MatType matrix;
	int i, j;
	long rowSize = NumCol*sizeof(ti_float);
	long columnSize = NumRow * sizeof(PFloat);
	matrix = (MatType) malloc(columnSize + rowSize*NumRow);
	if (matrix)	{
		PFloat temp = matrix + NumRow;
		for (i=0; i<NumRow; i++) {
			matrix[i] = temp;
		  for (j=0; j<NumCol; j++) temp[j] = ZERO;
			temp += NumCol;
		}
	}
  return matrix;
}